;--------------------------------------
                                ;0123456701234567
scl_reset:      db      LINE2,  "Reset Success.. "
;--------------------------------------
message_init:
                mov     dptr,#scl_init
                lcall   write_line

                mov     dptr,#scl_wait
                lcall   write_line
                ret
;--------------------------------------
;reset CD-ROM
init_cdrom:
                lcall   message_init
;hardware reset
                clr     B_RESET
                lcall   atapi_delay
                lcall   atapi_delay
                setb    B_RESET
;software Reset
Soft_Reset:
                lcall   set_status
                lcall   read
                mov     a,DatabusL
                anl     a,#010001000b
                jnz     Soft_Reset
                lcall   Set_Command
                mov     DDL,#08h        ;soft Reset
                mov     DDH,#0h
                lcall   write
                lcall   atapi_delay
;--------------------------------------
start_unit:
                lcall   Send_Packet
                lcall   Set_Data
                mov     DDL,#01bh       ;Operation Code
                mov     DDH,#00h        ;Reversed Bit 0, Immed = 0
                lcall   write
;
                mov     DDL,#0          ;Reversed 
                lcall   write
;
                mov     DDL,#01h
                mov     DDH,#0h
                lcall   write
;
                mov     DDH,#0
                lcall   write
                lcall   write
                lcall   write
                lcall   wait_INTRQ
                ret

;--------------------------------------
Read_TOCdata:
                                ;wait for DRQ = 1
                lcall   Set_Status
                lcall   read
                mov     a,DatabusL
                anl     a,#0000001000b  ;wait DRQ = 1
                jz      Read_TOCdata
;
                lcall   Set_Data
                lcall   read
                mov     a,DatabusH
                mov     TOC_Lenght,a    ;maximum 36 track
;
                lcall   read
                mov     a,DatabusL
                mov     First_Track,a
                mov     a,DatabusH
                mov     Last_Track,a

                dec     TOC_Lenght
                dec     TOC_Lenght
;allocate the first portion of memory here
                mov     dph,#0
                mov     dpl,#MEM_TOC
;
Next_Descriptor:
                lcall   read
                lcall   read
                lcall   read
;M-Field
                mov     a,dpl
                cpl     a










                ret
;--------------------------------------
Read_TOC:
                lcall   Send_Packet
                lcall   Set_Data
                mov     DDL,#043h       ;Read Sub-Channel Command
                mov     DDH,#002h       ;reverse Bit1 = MSF, bit0 = Reverse
                lcall   write
;
                mov     DDL,#00h        ;reverse, Format
                mov     DDH,#00h
                lcall   write
;
                mov     DDL,#00h        ;reversed
                mov     DDH,#00h
                lcall   write
;
                mov     DDL,#00h        ;Start Track
                mov     DDH,#00h        ;Allocate Lenght (MSB)
                lcall   write
;
                mov     DDL,#00h        ;Allocate Lenght (LSB)
                mov     DDH,#00h        ;Formate Reversed
                lcall   write
;
                mov     DDL,#00h        ;reverse
                mov     DDH,#00h
                lcall   write
;
                lcall   Wait_INTRQ
                lcall   Read_TOCdata
                ret
;--------------------------------------
wait_INTRQ:
                mov     a,ctrl
                anl     a,#01000000b
                jz      wait_INTRQ
;
                lcall   Set_Status
                lcall   read
                lcall   Set_causeofInt  ;To Clear the interrupt for Data in
                lcall   read
                ret
;--------------------------------------
Send_Packet:
                lcall   set_status
                lcall   read

                mov     a,DatabusL
                anl     A,#010001000b
                jnz     Send_Packet     ;wait busy = 0, DRQ = 0
;
                lcall   Set_DriveSelect
                mov     DDL,#011100000b ;select Drive 0, LBA
                mov     DDH,#0
                lcall   write
;
                lcall   Set_ByteCountLow
                mov     DDL,#0ffh       ;maximum 255
                lcall   write
                lcall   Set_ByteCountHigh
;
                mov     DDL,#0ffh
                lcall   write
                lcall   Set_Feature
                lcall   write
                lcall   Set_Command
                mov     DDL,#0a0h
                lcall   write
Wait_DRQ:
                lcall   Set_Status
                lcall   read
                mov     a,DatabusL
                anl     a,#0100010000b
                cjne    a,#0000010000b,Wait_DRQ
                ret
;--------------------------------------
Set_causeofInt:
Set_Feature:
                clr     CS0
                setb    CS1
                clr     DA2
                setb    DA1
                clr     DA0
                ret
;--------------------------------------
Set_ByteCountLow:
                clr     CS0
                setb    CS1
                setb    DA2
                clr     DA1
                clr     DA0
                ret
;--------------------------------------
Set_ByteCountHigh:
                clr     CS0
                setb    CS1
                setb    DA2
                clr     DA1
                setb    DA0
                ret
;--------------------------------------
Set_DriveSelect:
                clr     CS0
                setb    CS1
                setb    DA2
                setb    DA1
                clr     DA0
                ret
;--------------------------------------
Set_Command:
Set_Status:
                clr     CS0
                setb    CS1
                setb    DA2
                setb    DA1
                setb    DA0
                ret
;--------------------------------------
Set_Data:
                clr     CS0
                setb    CS1
                clr     DA2
                clr     DA1
                clr     DA0
                ret
;--------------------------------------
read:
                clr     DIOR
                mov     a,DDL
                mov     DatabusL,a
                mov     a,DDH
                mov     DatabusH,a
                setb    DIOR
                mov     DDH,#ATAPI_LOW
                ret
;--------------------------------------
write:
                nop
                clr     DIOW
                nop
                setb    DIOW
                ret
;--------------------------------------
