;Project CD-ROM interface ATAPI
;By Arampee


;RD2
Bau_RD2         equ     0fah

;C52
Bau_C52         equ     0fdh

Start_CD        equ     1

                org     20h
flag:           ds      1
flag_cmd        bit     flag.0          ;for lcd command
flag_serial     bit     flag.1
flag_disc       bit     flag.2          ;disc insert
flag_eject      bit     flag.3
flag_play       bit     flag.4
flag_subb       bit     flag.5
flag_pause      bit     flag.6
flag_error      bit     flag.7

                org     21h
flag_II:        ds      1
flag_repeat     bit     flag_II.0



disbuff:        ds      17              ;17 byte buffer

;for function hex to decimal
mem_buff:       ds      3

xbyte_d:        ds      1
xbyte_l:        ds      1
xbyte_h:        ds      1

audio_status:   ds      1
packet_size:    ds      1
start_track:    ds      1
total_track:    ds      1
track_play:     ds      1

index_play:     ds      1
min:            ds      1
sec:            ds      1

tmp:            ds      1
tmp0:           ds      1
tmp1:           ds      1
tmp2:           ds      1
tmp3:           ds      1

Start_M:        ds      1
Start_S:        ds      1
Start_F:        ds      1
End_M:          ds      1
End_S:          ds      1
End_F:          ds      1

packet:
packet_cmd:     ds      1
packet_1:       ds      1
packet_2:       ds      1
packet_3:       ds      1
packet_4:       ds      1
packet_5:       ds      1
packet_6:       ds      1
packet_7:       ds      1
packet_8:       ds      1
packet_9:       ds      1
packet_10:      ds      1
packet_11:      ds      1
packet_12:      ds      1
packet_13:      ds      1
packet_14:      ds      1
packet_15:      ds      1

                org     70h
TOC_file:       ds      30*3            ;maximum 25 track (3 byte / track)

stack           equ     255-30



                org     0
                ljmp    main

                reti

                org     1bh             ;
                reti

                org     23h             ;service Serial Interrupt
                ljmp    rx_int

main:
                mov     sp,#stack
                mov     psw,#0

                mov     scon,#01010000B     ;set Mode 1  8 bit Asynchronus
                                            ;ren = 1 Enable Serial Port
                                            ;TB8,RB8 = 0 stop bit
                                            ;TI,RI
                mov     tmod,#00100000B     ;set mode (timer)

                                            ;mode 2 Auto Reload 8 bit)
                mov     tcon,#01010000B     ;timer0,1 internal count

                mov     th1,#Bau_C52
                mov     tl1,#Bau_C52

                setb    tr1

                clr     ea                  ;enable all interrupt

                mov     flag,#0
                mov     flag_II,#0              ;clear bit flag

                lcall   init_lcd
                mov     dptr,#scl_init
                lcall   write_line
                mov     dptr,#scl_wait
                lcall   write_line
                mov     r2,#5
                lcall   dtsec
;
                lcall   init_ata_device         ;initilize CD-ROM

                lcall   atapi_identify_device   ;check Company CD-ROM

                lcall   wait_for_ready          ;check media

                mov     dptr,#scl_cmd
                lcall   write_line

                mov     track_play,#1
                setb    es
                setb    ea
;--------------------------------------
wait_serial:
                jb      flag_disc,none_Chk
                lcall   wait_for_ready
;                ajmp    wait_serial
none_Chk:
                jnb     flag_serial,menu_exit
                mov     a,tmp
                clr     flag_serial
key_1:
                cjne    a,#'e',key_2            ;Eject / Closed Tray
                clr     flag_repeat             ;clear flag repeat
                lcall   atapi_eject
                ljmp    menu_exit
key_2:
                cjne    a,#'r',key_3            ;reverse
                jnb     flag_disc,menu_exit
                lcall   atapi_rew_track
                ljmp    menu_exit
key_3:
                cjne    a,#'p',key_4
                jnb     flag_disc,menu_exit
                jb      flag_play,menu_exit
                mov     track_play,#Start_CD    ;play track
                lcall   play_CD
                ljmp    menu_exit
key_4:
                cjne    a,#'f',key_5
                jnb     flag_disc,menu_exit
                lcall   atapi_few_track ;forword track
                ljmp    menu_exit


key_5:
                cjne    a,#'s',key_6
                jnb     flag_disc,menu_exit
                clr     flag_repeat             ;clear flag repeat
                lcall   atapi_stop              ;stop
                clr     flag_play
                ljmp    menu_exit
key_6:
;may be Remote Control
                cjne    a,#'t',key_7            ;track 2 byte
                jnb     flag_disc,menu_exit
                clr     es
                lcall   get_remote
                setb    es
                ljmp    menu_exit
key_7:
                cjne    a,#'x',key_8
                jnb     flag_disc,menu_exit     ;pause
                lcall   atapi_pause
                ljmp    menu_exit
key_8:
                cjne    a,#'g',key_9            ;repeat track
                cpl     flag_repeat
                mov     r2,#10
                lcall   dtsec
                ljmp    menu_exit
key_9:
                cjne    a,#'n',key_10           ;on /off
                lcall   clear_screen
                ljmp    menu_exit
key_10:
menu_exit:
                jnb     flag_play,none_Display_Time
                jb      flag_pause,none_Display_Time
                clr     es
                lcall   read_subchanCmd         ;display time
                mov     a,audio_status
                cjne    a,#13h,none_stop

                jb      flag_repeat,repeat_disc
                lcall   atapi_stop
                ljmp    none_stop
repeat_disc:
                mov     track_play,#Start_CD
                lcall   Play_CD
none_stop:
                mov     r2,#3
                lcall   dtsec
                setb    es
none_Display_Time:
                mov     tmp,#0
                mov     a,SBUF
                clr     ri
                ljmp    wait_serial
;--------------------------------------
dtsec:          mov     r6,#179
dtsec1:         mov     r7,#0h
                djnz    r7,$
                djnz    r6,dtsec1
                djnz    r2,dtsec
                ret

;--------------------------------------
get_remote:
;first byte
                mov     dptr,#scl_shiftTrack
                lcall   write_line
                mov     a,#LINE2+12
                lcall   goto_xy

                lcall   rx_byte
                cjne    a,#'c',digit_one
                ljmp    Shift_exit
digit_one:
                lcall   write_lcd
                clr     c
                subb    a,#30h
                anl     a,#0fh
                swap    a
                anl     a,#0f0h
                mov     xbyte_h,a
;1's
;secound byte
                lcall   rx_byte
                cjne    a,#'c',next_digit
                ljmp    Shift_Exit
next_digit:
                lcall   write_lcd
                clr     c
                subb    a,#30h
                anl     a,#0fh
                orl     a,xbyte_h
once_track:
                mov     xbyte_d,a

;success 2 byte
                mov     xbyte_h,#0
                mov     xbyte_l,#0

                lcall   dtoh

                mov     r2,#2
                lcall   dtsec

                mov     a,total_track   ;
                mov     b,xbyte_l       ;Reload
                clr     c
                subb    a,b
                jc      Over_Track
                mov     a,b             ;reload
                xrl     a,#0
                jz      Over_track
                mov     a,b
                mov     track_play,a    ;play track
                lcall   play_CD
Over_Track:
Shift_Exit:
                ret
;--------------------------------------
power_down:
                clr     ATA_nRESET
                lcall   Atapi_Delaytime
                setb    ATA_nRESET
                mov     dptr,#scl_blank1
                lcall   write_line
                mov     dptr,#scl_blank2
                lcall   write_line
                ret
;--------------------------------------
clear_screen:
                jnb     flag_disc,key9_exit
                clr     flag_repeat             ;clear flag repeat
                lcall   atapi_stop              ;stop
                clr     flag_play
                mov     dptr,#scl_blank1
                lcall   write_line
                mov     dptr,#scl_poweroff
                lcall   write_line
key9_exit:
                ret
;--------------------------------------
                                ;0123456701234567
scl_cmd:        db      LINE1,  "Press Command ? "
scl_init:       db      LINE1,  "  Initialize    "
scl_wait:       db      LINE2,  " Please Wait... "
scl_test:       db      LINE2,  "***** done *****"
scl_readTOC:    db      LINE1,  " TOC Reading... "
scl_blank1:     db      LINE1,  "                "
scl_blank2:     db      LINE2,  "                "
scl_poweroff:   db      LINE2,  "----  OFF.  ----"
scl_shiftTrack: db      LINE2,  "Shift Track     "
;--------------------------------------
                $include        "lcd.asm"
                $include        "cdrom.asm"
                $include        "serial.asm"
                $include        "util.asm"
                end

