;
;Command for control CD-ROM
;
;
CMD_PWR         EQU     'u'     ;POWER
CMD_EJECT       EQU     'e'     ;EJECT
CMD_STOP        EQU     's'     ;STOP
;
CMD_PLAY        EQU     'p'     ;PLAY
CMD_FF          EQU     'f'     ;FORWORD TRACK
CMD_REW         EQU     'r'     ;REWORD TRACK
;
CMD_PAUSE       EQU     'x'     ;PAUSE
CMD_REPEAT      EQU     'g'     ;REPEAT DISC
CMD_TRACK       EQU     't'     ;TRACK SEEK
                                ;2 BYTE ASCII THEN CANCEL 'c'

CMD_BEFOREOFF   EQU     'n'     ;before off CD-ROM

CMD_TRACKONCE   EQU     'o'     ;TRACK 1-9

REMOTE_PWR      EQU     0A8H    ;POWER
REMOTE_EJECT    EQU     042H    ;EJECT  (CD SELECT)
REMOTE_STOP     EQU     01CH    ;STOP
;
REMOTE_PLAY     EQU     4CH     ;PLAY
REMOTE_FF       EQU     8CH     ;FF
REMOTE_REW      EQU     0CH     ;REW
;
REMOTE_PAUSE    EQU     9CH     ;PAUSE
REMOTE_REPEAT   EQU     38H     ;REPEAT DISC (DISPLAY)

REMOTE_MORE     EQU     0B0H    ;MORE THAN 10 TRACK

                ORG     20H
FLAG:           DS      1       ;TEMP FLAG
FLAG_TIMEOUT    BIT     FLAG.0          ;TIMEOUT
FLAG_REMOTE     BIT     FLAG.1

FLAG_ERR        BIT     FLAG.2
FLAG_FIRST_T    BIT     FLAG.3
FLAG_SECOND     BIT     FLAG.4


BIT_COMMAND:    DS      1       ;CMD FOR REMOTE
BIT_ADDRESS:    DS      1       ;ADDRESS FOR SONY
STACK:          DS      1

COUNTER         EQU     0C0H    ;02, 92H = 652 uS
                                ;02, B0H = 775 uS
                                ;02, C0H = 840 uS
MAX             EQU     0FFH


; I / O
IR_REMOTE       BIT     P1.0    ;IR = 1.0

RST             BIT     P3.2    ;RESET NEXT CPU
TXD_BIT         BIT     P3.1    ;TX 110 BOUD RATE


LED              BIT     P1.1

K_POWER          BIT     P1.2
K_EJECT          BIT     P1.3
K_STOP           BIT     P1.4
K_PLAY           BIT     P1.5
K_REW            BIT     P1.6
K_FFW            BIT     P1.7



                ORG     0
                LJMP    MAIN

                ORG     3H
                RETI

                ORG     0BH
                RETI

                ORG     23H
                RETI


                ORG     50H
REMOTE_TBL:     DB      30H                     ;0
                DB      000H,   080H,   040H    ;123
                DB      0C0H,   020H,   0A0H    ;456
                DB      060H,   0E0H,   010H    ;789
                DB      0FFH                    ;0 command 't'

                ORG     80H
MAIN:
                MOV     SP,#STACK       ;STACK POINTER
                MOV     SCON,#01010010b ;set Mode 1  8 bit Asynchronus
                                        ;ren = 1 Enable Serial Port
                                        ;TB8,RB8 = 0 stop bit
                                        ;TI,RI
                MOV     TMOD,#00100000B ;set mode (timer)
                                        ;mode 2 Auto Reload 8 bit)



                MOV     TH1,#0FDH

                SETB    TR1

                MOV     FLAG,#0         ;
                SETB    RST             ;
                NOP
                NOP
                CLR     ES
                CLR     EA            ;DISABLE ALL INTERRUPT
;CLOCK GEN
                SETB    IR_REMOTE       ;SET ACTIVE HIGH REMOTE IN
                SETB    LED

;START HERE  SONY COMMAND IS

                MOV     FLAG,#0
START:
CLEAR_BIT:
                MOV     BIT_COMMAND,#0FFH  ;CLEAR COMMAND
                MOV     BIT_ADDRESS,#0FFH  ;CLEAR ADDRESS
                NOP
                NOP

                LCALL   GET_REMOTE
GET_KEY:
                NOP
                MOV     A,P1
                ANL     A,#11111100B
                XRL     A,#11111100B
                JZ      START
;-------------------------------------------
CHECK_KEY:
                JB      FLAG_FIRST_T,K_EXIT

                SETB    K_POWER
                NOP
                JB      K_POWER,K2
                MOV     A,#CMD_PWR
                JB      RST,EXIT_K1
                LCALL   ONOFF
EXIT_K1:
                CPL     RST             ;RESET POWER ON / OFF
                CPL     LED
                JNB     K_POWER,$
                AJMP    K7
K2:
                SETB    K_EJECT
                NOP
                JB      K_EJECT,K3
                MOV     A,#CMD_EJECT
                LCALL   TX
                JNB     K_EJECT,$
                AJMP    K7
K3:
                SETB    K_PLAY
                NOP
                JB      K_PLAY,K4
                MOV     A,#CMD_PLAY
                LCALL   TX
                JNB     K_PLAY,$
                AJMP    K7
K4:
                SETB    K_STOP
                NOP
                JB      K_STOP,K5
                MOV     A,#CMD_STOP
                LCALL   TX
                JNB     K_STOP,$
                AJMP    K7

K5:
                SETB    K_REW
                NOP
                JB      K_REW,K6
                MOV     A,#CMD_REW
                LCALL   TX
                JNB     K_REW,$
                AJMP    K7
K6:
                SETB    K_FFW
                NOP
                JB      K_FFW,K7
                MOV     A,#CMD_FF
                LCALL   TX
                JNB     K_FFW,$
K7:
K_EXIT:
                LCALL   UTIL_PRESS
                LJMP    START
;----------------------------------------
GET_REMOTE:
                JB      IR_REMOTE,GET_EXIT
                NOP
                JB      IR_REMOTE,GET_EXIT

                LCALL   GET_IR                  ;RECIVED REMOTE

                JNB     FLAG_REMOTE,GET_EXIT

                LCALL   GET_COMMAND
GET_EXIT:
                RET
;----------------------------------------
GET_COMMAND:

                MOV     A,BIT_COMMAND
                JB      FLAG_FIRST_T,SEND_2BYTE
REM_1:
                CJNE    A,#REMOTE_PWR,REM_2
                MOV     A,#CMD_PWR              ;POWER
                JB      RST,EXIT_REM1
                LCALL   ONOFF
EXIT_REM1:
                CPL     RST             ;RESET POWER ON / OFF
                CPL     LED
                LJMP    EXIT_D
REM_2:
                CJNE    A,#REMOTE_EJECT,REM_3
                MOV     A,#CMD_EJECT            ;EJECT
                LJMP    EXIT_GET_CMD
REM_3:
                CJNE    A,#REMOTE_STOP,REM_4
                MOV     A,#CMD_STOP             ;STOP
                LJMP    EXIT_GET_CMD

REM_4:
                CJNE    A,#REMOTE_PLAY,REM_5
                MOV     A,#CMD_PLAY             ;PLAY
                LJMP    EXIT_GET_CMD

REM_5:
                CJNE    A,#REMOTE_FF,REM_6
                MOV     A,#CMD_FF               ;FF
                LJMP    EXIT_GET_CMD

REM_6:
                CJNE    A,#REMOTE_REW,REM_7
                MOV     A,#CMD_REW              ;REW
                LJMP    EXIT_GET_CMD

REM_7:
                CJNE    A,#REMOTE_PAUSE,REM_8
                MOV     A,#CMD_PAUSE            ;PAUSE
                LJMP    EXIT_GET_CMD
REM_8:
                CJNE    A,#REMOTE_REPEAT,REM_9
                MOV     A,#CMD_REPEAT           ;REPEAT TRACK
                LJMP    EXIT_GET_CMD

REM_9:
                CJNE    A,#REMOTE_MORE,REM_A
                MOV     A,#CMD_TRACK            ; 't' 2 TRACK FOR SEND

                SETB    FLAG_FIRST_T            ;SET FLAG FOR RECIVE 2 BYTE
                CLR     FLAG_SECOND
                LJMP    EXIT_GET_CMD            ;MORE 10 TRACK
REM_A:
                LCALL   FIND_TRACK
                JB      FLAG_ERR,NOT_SEND
                JB      FLAG_FIRST_T,SEND_2BYTE
                MOV     B,A
                XRL     A,#'0'                  ;TRACK 0 NOT HAVE
                JZ      EXIT_D                  ;IF PRESS "0" THEN NOT ACTIVE
                PUSH    ACC
                MOV     A,#'t'
                LCALL   SEND_DELAY
                SETB    FLAG_SECOND
                MOV     A,#'0'
                LCALL   SEND_DELAY
                POP     ACC
                MOV     A,B
                LCALL   SEND_DELAY
                LJMP    SUCCESS_2BYTE
SEND_2BYTE:
                LCALL   FIND_TRACK
                JNB     FLAG_ERR,REM_B
                MOV     A,#'c'
                LCALL   SEND_DELAY
;                MOV     A,#'c'
;                LCALL   TX
                LJMP    EXIT_D
REM_B:
                LCALL   TX
                JB      FLAG_SECOND,SUCCESS_2BYTE
                SETB    FLAG_SECOND             ;
                LJMP    EXIT_D
SUCCESS_2BYTE:
                CLR     FLAG_FIRST_T
                CLR     FLAG_SECOND
NOT_SEND:
                AJMP    EXIT_D
EXIT_GET_CMD:
                LCALL   TX
EXIT_D:
                MOV     R2,#3
                LCALL   DTSEC
                RET
;----------------------------------------
FIND_TRACK:
                MOV     B,#0
                CLR     FLAG_ERR                ;CLEAR FLAG ERROR
                MOV     DPTR,#REMOTE_TBL
FIND_T_NEXT:
                CLR     A
                MOVC    A,@A+DPTR
                XRL     A,BIT_COMMAND
                JZ      FIND_T_EXIT
                INC     B
                INC     DPTR
                MOV     A,B
                XRL     A,#12                   ;11 KEY COMPARE
                JNZ     FIND_T_NEXT
                SETB    FLAG_ERR                ;SET FLAG ERROR
                RET

FIND_T_EXIT:    MOV     A,B
                LCALL   HTOA
                MOV     A,R3                    ;SEND LSB
                RET
;----------------------------------------
ONOFF:
                MOV     R2,#10
                LCALL   DTSEC
                MOV     A,#'n'
                LCALL   TX
                MOV     R2,#30
                LCALL   DTSEC
                NOP
                NOP
                RET
;----------------------------------------
SEND_DELAY:
                LCALL   TX
                MOV     R2,#4
                LCALL   DTSEC
                RET
;----------------------------------------
                $INCLUDE        "SONY.ASM"
                $INCLUDE        "UTIL.ASM"
                END
