LINE1           equ     0
LINE2           equ     40h


point           equ     16      ;16 char

lcd_clk         bit     P2.0
lcd_data        bit     P2.1
lcd_e           bit     P2.2

;--------------------------------------
delay:
                mov     r4,#0h
                djnz    r4,$
                djnz    r2,delay
                ret
;--------------------------------------
print_lcd:
                lcall   htoa
                mov     a,r2
                lcall   write_lcd
                mov     a,r3
                lcall   write_lcd
                ret
;--------------------------------------
write_lcd:
                setb    flag_cmd
                lcall   write_byte
                ret
;--------------------------------------
write_byte:
                push    b
                push    acc
                mov     b,#8           ;shift 8 bit
send_lcd:

                rlc     a
                mov     lcd_data,c
                nop

                clr     lcd_clk
                nop
                setb    lcd_clk
                nop

                djnz    b,send_lcd

                clr     lcd_clk
                nop
                setb    lcd_clk
                nop

                jb      flag_cmd,RS_HIGH

                clr     lcd_data
                ajmp    RS_exit
RS_HIGH:
                setb    lcd_data
RS_exit:
                nop
                clr     lcd_e

                mov     r2,#1
                lcall   delay

                setb    lcd_e
                mov     r2,#1
                lcall   delay
                pop     acc
                pop     b
                ret

;--------------------------------------
write_disbuf:
                mov     a,#LINE2
                lcall   goto_xy
;
                setb    flag_cmd
                mov     r0,#disbuff
                mov     b,#point
write_Char:
                push    b
                mov     a,@r0
                lcall   write_byte
                inc     r0
                pop     b
                djnz    b,write_Char
                ret
;--------------------------------------
write_line:
                clr     a
                movc    a,@a+dptr
                lcall   goto_xy
                inc     dptr

                setb    flag_cmd
                mov     b,#point
se_lcd:
                push    b
                clr     a
                movc    a,@a+dptr
                lcall   write_byte
                inc     dptr
                pop     b
                djnz    b,se_lcd
                ret
;--------------------------------------
goto_xy:
                clr     flag_cmd
                setb    acc.7           ;set bit 7 are goto_xy
                lcall   write_byte
                ret
;--------------------------------------
init_lcd:
                setb    lcd_e
                setb    lcd_clk
                                        ;delay time for initialize
                mov     r2,#5
                lcall   delay

                clr     flag_cmd        ;if flag_cmd == "1" then RS = LOW;
                mov     a,#38h          ;cmd
                lcall   write_byte

                mov     a,#0fh          ;cmd
                lcall   write_byte

                mov     a,#06h          ;cmd
                lcall   write_byte

                mov     a,#01h          ;cmd
                lcall   write_byte

                ret
;--------------------------------------
;HEX TO ASC
HTOA:           PUSH   ACC
                SWAP   A
                LCALL  HTOAS
                MOV    R2,A
                POP    ACC
                LCALL  HTOAS
                MOV    R3,A
                RET

HTOAS:          ANL    A,#0FH
                CJNE   A,#0AH,$+3
                JNC    HTOAS1
                ORL    A,#'0'           ;0x30H
                RET
HTOAS1:         SUBB   A,#9
                ORL    A,#'@'           ;0x40H
                RET



