;FOR SONY REMOTE CONTROL
;MODEL RMT-C550
;
;0A8H   -> POWER
;04CH   -> PLAY
;9CH    -> PAUSE
;0CH    -> REW 1 TRACK
;8CH    -> FORWORD 1 TRACK
;1C     -> STOP
;5C     -> FAST REVERSE
;DC     -> FAST FORWORD

;00     -> 1
;80        2
;40        3
;C0        4
;20        5
;0A0       6
;060       7
;0E0       8
;010       9
;036    -> 0
;0B0    -> +10
;
;38     -> DISPLAY
;42     -> CD
;82     -> RADIO
;02     -> TAPE
;
;88     -> MODE
;28     -> MUTE
;48H    -> VOL +
;C8     -> VOL -




BYTE_ADDRESS    EQU     04H             ;ANL D4H,44H
BYTE_ERROR      EQU     0DH             ;ERROR


GET_IR:
                CLR     FLAG_REMOTE
                MOV     R5,#3               ;SONY "L" 2.4 mS
BUSY:
                LCALL   BUSY_SIGNAL
                DJNZ    R5,BUSY
                JNB     IR_REMOTE,$         ;WAIT SIGNAL ACTIVE HIGH
RECIVE:
;THIS STEP READ COMMAND
                MOV     R0,#BIT_COMMAND
                MOV     B,#8                ;8 BIT COMMAND
                MOV     R7,#0
D_READ:
                DEC     R7
                MOV     A,R7
                XRL     A,#0
                JZ      EXIT_IR
                JB      IR_REMOTE,D_READ
                LCALL   FIND_BIT

                DJNZ    B,D_READ
;NEXT STEP READ ADDRESS
                MOV     R0,#BIT_ADDRESS     ;4 BIT ADDRESS
                MOV     B,#4
                MOV     R7,#0
A_READ:
                DEC     R7
                MOV     A,R7
                XRL     A,#0
                JZ      EXIT_IR

                JB      IR_REMOTE,A_READ

;AFTER GET FILE FROM REMOTE READY
;
                LCALL   FIND_BIT
                DJNZ    B,A_READ

;NONE COMPARE BIT ADDRESS
;
;                LCALL   CH_CMD

                MOV     A,BIT_ADDRESS
                ANL     A,#0FH          ;MARK 4 BIT (LSB)
                XRL     A,#BYTE_ADDRESS
                JNZ     NONE_SONY
                SETB    FLAG_REMOTE
NONE_SONY:
EXIT_IR:
                RET
;-------------------------------------
UTIL_PRESS:
                MOV     R7,#MAX
WAITMAX:
                MOV     R6,#MAX
                DJNZ    R6,$
                DJNZ    R7,WAITMAX
                RET
;-------------------------------------
CH_CMD:
;MAY BE IF ADD FUNCTION TO LCD DISPLAY
                MOV     A,BIT_COMMAND
                LCALL   SEND_TEST
                MOV     A,BIT_ADDRESS
                LCALL   SEND_TEST
                MOV     A,#0AH
                LCALL   TX
                MOV     A,#0DH
                LCALL   TX
                LCALL   UTIL_PRESS
                RET
;-------------------------------------
; 1 CYCLE TIME IS 650 uS
; DELAY TIME 650 uS  DATA COUNTER IS 02H, 92H
FIND_BIT:
                CLR     C
                LCALL   BUSY_SIGNAL
                JB      IR_REMOTE,ABORT
                SETB    C
ABORT:
                MOV     A,@R0
                RLC     A
                MOV     @R0,A               ;STORE
                JNB     IR_REMOTE,$         ;WAIT FOR ACTIVE HIGH AGAIN
                RET
;-------------------------------------
; WAIT TIME IS MORE > 650 uS
BUSY_SIGNAL:
                MOV     R6,#02H
DELAY:          MOV     R7,#COUNTER         ;DATA FOR WAIT 1 PULSE CYCLE
                DJNZ    R7,$
                DJNZ    R6,DELAY
                RET
