GET_IR:
                MOV     R5,#3               ;SONY "L" 2.4 mS
BUSY:
                LCALL   BUSY_SIGNAL
                DJNZ    R5,BUSY
                JNB     IR_REMOTE,$         ;WAIT SIGNAL ACTIVE HIGH
RECIVE:
;THIS STEP READ COMMAND
                MOV     R0,#BIT_COMMAND
                MOV     B,#8                ;8 BIT COMMAND
                MOV     R7,#0
D_READ:
                DEC     R7
                MOV     A,R7
                XRL     A,#0
                JZ      EXIT_IR
                JB      IR_REMOTE,D_READ
                LCALL   FIND_BIT

                DJNZ    B,D_READ
;NEXT STEP READ ADDRESS
                MOV     R0,#BIT_ADDRESS     ;4 BIT ADDRESS
                MOV     B,#4
                MOV     R7,#0
A_READ:
                DEC     R7
                MOV     A,R7
                XRL     A,#0
                JZ      EXIT_IR

                JB      IR_REMOTE,A_READ
                LCALL   CH_CMD
                LCALL   SEND_CMD
NONE_SEND:
                LCALL   UTIL_PRESS
NONE_SONY:
EXIT_IR:
                RET
;-------------------------------------
SEND_CMD:
                MOV     A,BIT_COMMAND

                CJNE    A,#REMOTE_PWR,C1              ;PWR
                CPL     RST
                CPL     LED
                NOP
                NOP
                NOP
                RET
C1:
                CJNE    A,#REMOTE_PLAY,C2              ;PLAY
                MOV     A,#CMD_PLAY
                LCALL   TX
                RET
C2:
                CJNE    A,#REMOTE_STOP,C3               ;STOP
                MOV     A,#CMD_STOP
                LCALL   TX
                RET
C3:
                CJNE    A,#REMOTE_EJECT,C4               ;EJECT
                MOV     A,#CMD_EJECT
                LCALL   TX
                RET
C4:
                CJNE    A,#REMOTE_REW,C5               ;REW
                MOV     A,#CMD_REW
                LCALL   TX
                RET
C5:
                CJNE    A,#REMOTE_FF,EXIT_R           ;FF
                MOV     A,#CMD_FF
                LCALL   TX
                RET
EXIT_R:
                MOV     A,#0
                RET
;-------------------------------------
UTIL_PRESS:
                MOV     R7,#MAX
WAITMAX:
                MOV     R6,#MAX
                DJNZ    R6,$
                DJNZ    R7,WAITMAX
                RET
;-------------------------------------
CH_CMD:
;MAY BE IF ADD FUNCTION TO LCD DISPLAY
                MOV     A,BIT_COMMAND
                LCALL   SEND_TEST
                MOV     A,BIT_ADDRESS
                LCALL   SEND_TEST
                MOV     A,#0AH
                LCALL   TX
                MOV     A,#0DH
                LCALL   TX
                LCALL   UTIL_PRESS
                RET
;-------------------------------------
; 1 CYCLE TIME IS 650 uS
; DELAY TIME 650 uS  DATA COUNTER IS 02H, 92H
FIND_BIT:
                CLR     C
                LCALL   BUSY_SIGNAL
                JB      IR_REMOTE,ABORT
                SETB    C
ABORT:
                MOV     A,@R0
                RLC     A
                MOV     @R0,A               ;STORE
                JNB     IR_REMOTE,$         ;WAIT FOR ACTIVE HIGH AGAIN
                RET
;-------------------------------------
; WAIT TIME IS MORE > 650 uS
BUSY_SIGNAL:
                MOV     R6,#02H
DELAY:          MOV     R7,#COUNTER         ;DATA FOR WAIT 1 PULSE CYCLE
                DJNZ    R7,$
                DJNZ    R6,DELAY
                RET
